unit TernarySeries;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, VclTee.TeeGDIPlus, Vcl.ExtCtrls,
  VCLTee.TeEngine, VCLTee.TeeSurfa, VCLTee.TeeTernary, Vcl.StdCtrls,
  VCLTee.TeeProcs, VCLTee.Chart, VCLTee.TeeURL, VCLTee.TeeSeriesTextEd, Data.DB,
  kbmMemTable, unitkbmmemorytable, commasplit, kbmMemCSVStreamFormat, Data.Win.ADODB,VCLTee.Series,
  VCLTee.DBChart;

type
  TTernarySeriesForm = class(TForm)
    Button1: TButton;
    Panel1: TPanel;
    SeriesTextSource1: TSeriesTextSource;
    kbmCSVStreamFormat1: TkbmCSVStreamFormat;
    Chart1: TDBChart;
    kbmMemTable1: TkbmMemTable;
    kbmMemTable2: TkbmMemTable;
    kbmMemTable3: TkbmMemTable;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Chart1BeforeDrawAxes(Sender: TObject);
  private
    SeriesListT: TStringList;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  TernarySeriesForm: TTernarySeriesForm;
  Series1: TTernarySeries;
  Series2: TTernarySeries;
  Series3: TTernarySeries;

implementation

{$R *.dfm}

Uses EditChar, TeeConst;

procedure TTernarySeriesForm.Button1Click(Sender: TObject);
begin
  EditSeries(Self,Series1);
end;

procedure TTernarySeriesForm.Chart1BeforeDrawAxes(Sender: TObject);
begin
//  Chart1.Legend.Title.Visible := Series1.ColorEachPoint;
  Chart1.Legend.Title.Visible := True;
end;

procedure TTernarySeriesForm.FormCreate(Sender: TObject);
var
  z: boolean;
  Lkbm: TkbmMemTable;
  af: TFieldDefs;
  i: integer;
  LADO: TADOQuery;
  aDataset1, aDataset2, aDataset3: TDataset;

begin
  inherited;

  kbmMemTable1 := TkbmMemTable.Create(nil);
  kbmMemTable1.DefaultFormat := kbmCSVStreamFormat1;
  kbmMemTable1.CommaTextFormat := kbmCSVStreamFormat1;
//  aDataSet1 := kbmMemTable1;

  af := kbmMemTable1.FieldDefs;
  af.Clear;

  with af.AddFieldDef do
  begin
    Name := 'Sample Site';       // Text
    DataType := ftString;
  end;

  with af.AddFieldDef do
  begin
    Name := 'Sample Date';
    DataType := ftString;
  end;

  with af.AddFieldDef do
  begin
    Name := 'Na/1000';        // X
    DataType := ftFloat;
  end;

  with af.AddFieldDef do
  begin
    Name := 'Sqrt(Mg)';        // Y
    DataType := ftFloat;
  end;

  with af.AddFieldDef do
  begin
    Name := 'K/100';          // Z
    DataType := ftFloat;
  end;

  with af.AddFieldDef do
  begin
    Name := 'Conc Sum';          // Radius
    DataType := ftFloat;
  end;

  with af.AddFieldDef do
  begin
    Name := 'Weight';          // Weight
    DataType := ftFloat;
  end;

  with af.AddFieldDef do
  begin
    Name := 'Site and Date';          // Text
    DataType := ftString;
  end;

  kbmMemTable1.Open;
  kbmMemTable1.LoadFromFile('C:\Code_Test_Progs\TernaryGraph_MultiSeries\Na-Mg-K_1.csv');
  i := kbmMemTable1.RecordCount;

  Series1 := TTernarySeries.Create(Owner);
  Series1.ParentChart := Chart1;

  Series1.DataSource := kbmMemTable1;

  Series1.UseColorRange:=true;
  Series1.VertexTitles[0][0] := 'Na/1000' ;
  Series1.VertexTitles[1][0] := 'Sqrt(Mg)' ;
  Series1.VertexTitles[2][0] := 'K/100' ;

  Series1.XValues.ValueSource := 'Na/1000';
  Series1.YValues.ValueSource := 'Sqrt(Mg)';
  Series1.ZValues.ValueSource := 'K/100';
  Series1.WeightValues.ValueSource := 'Conc Sum';
  Series1.RadiusValues.ValueSource := 'Conc Sum';
  Series1.XLabelsSource := 'Site and Date';

  Series1.Pointer.Style:=psDonut;
  Series1.Pointer.Transparency:=50;

  kbmMemTable2 := TkbmMemTable.Create(nil);
  kbmMemTable2.DefaultFormat := kbmCSVStreamFormat1;
  kbmMemTable2.CommaTextFormat := kbmCSVStreamFormat1;

  kbmMemTable2.FieldDefs := kbmMemTable1.FieldDefs;

  kbmMemTable2.Open;
  kbmMemTable2.LoadFromFile('C:\Code_Test_Progs\TernaryGraph_MultiSeries\Na-Mg-K_2.csv');
  i := kbmMemTable2.RecordCount;

  Series2 := TTernarySeries.Create(Owner);
  Series2.ParentChart := Chart1;

  Series2.DataSource := kbmMemTable2;

  Series2.UseColorRange:=true;

  Series2.XValues.ValueSource := 'Na/1000';
  Series2.YValues.ValueSource := 'Sqrt(Mg)';
  Series2.ZValues.ValueSource := 'K/100';
  Series2.WeightValues.ValueSource := 'Conc Sum';
  Series2.RadiusValues.ValueSource := 'Conc Sum';
  Series2.XLabelsSource := 'Site and Date';

  Series2.Pointer.Style:=psCircle;
  Series2.Pointer.Transparency:=50;

  kbmMemTable3 := TkbmMemTable.Create(nil);
  kbmMemTable3.DefaultFormat := kbmCSVStreamFormat1;
  kbmMemTable3.CommaTextFormat := kbmCSVStreamFormat1;

  kbmMemTable3.FieldDefs := kbmMemTable2.FieldDefs;

  kbmMemTable3.Open;
  kbmMemTable3.LoadFromFile('C:\Code_Test_Progs\TernaryGraph_MultiSeries\Na-Mg-K_3.csv');
  i := kbmMemTable3.RecordCount;

  Series3 := TTernarySeries.Create(Owner);
  Series3.ParentChart := Chart1;

  Series3.DataSource := kbmMemTable3;

  Series3.UseColorRange:=true;

  Series3.XValues.ValueSource := 'Na/1000';
  Series3.YValues.ValueSource := 'Sqrt(Mg)';
  Series3.ZValues.ValueSource := 'K/100';
  Series3.WeightValues.ValueSource := 'Conc Sum';
  Series3.RadiusValues.ValueSource := 'Conc Sum';
  Series3.XLabelsSource := 'Site and Date';

  Series3.Pointer.Style:=psRectangle;
  Series3.Pointer.Transparency:=50;

  Series3.TernaryStyle:=tsBubble;
  Series3.TernaryLegendStyle:=tlsBubbleWeight;

  Chart1.Legend.TextStyle := ltsPlain;
  Chart1.Legend.Title.Text.Add('Sample Site  Sample Date');
  Chart1.Legend.Title.TextAlignment := taLeftJustify;
  Chart1.Legend.Width :=30;
  Chart1.Legend.Title.Visible:=true;
end;

end.
